@import "abstracts/abstracts";

$size-image: 125px;

:host {
  display: flex;
  align-items: center;
  justify-content: center;
  border: 1px solid $extra-light-grey;
  padding: 10px 20px;
  position: relative;

  .grid {
    width: 100%;
    display: grid;
    text-align: center;
    justify-content: center;
    grid-template-rows: min-content min-content min-content;

    .image-container {
      margin-top: 20px;
      margin-bottom: 10px;
      position: relative;
      display: flex;
      justify-content: center;

      .image-wrapper {
        position: relative;
      }
    }

    .orgunit-and-title {
      display: flex;
      flex-direction: column;
      justify-content: center;

      .orgunit {
        color: $light-grey;
        font-weight: bold;
        overflow: hidden;
        margin-bottom: 5px;
        max-width: 300px;

        ::ng-deep > * {
          @include truncate-with-ellipsis;
        }
      }

      .title {
        font-weight: bold;
        margin-bottom: 10px;
        max-width: 300px;
        @include truncate-with-ellipsis;
      }
    }

    .detailed-infos {
      display: grid;
      grid-template-columns: 1fr 1fr 1fr;
      grid-gap: 10px;
      align-items: center;
      justify-content: center;
      margin-bottom: 10px;

      .access-level {
        &.red {
          color: $red;
        }

        &.orange {
          color: $warning;
        }

        &.green {
          color: $green-sweet;
        }
      }

      .year,
      .access-level,
      .size {
        display: grid;
        grid-template-columns: min-content max-content;
        grid-gap: 10px;
        align-items: center;
        justify-content: start;
      }
    }

    .button-wrapper {
      text-align: center;
      visibility: hidden;
      display: flex;
      flex-wrap: wrap;
      justify-content: center;

      > * {
        margin: 5px;
      }

      .send-request-round-button {
        &.disabled {
          cursor: initial !important;
        }
      }
    }
  }

  &:hover {
    cursor: pointer;

    .grid {
      .button-wrapper {
        visibility: initial;
      }
    }
  }
}

:host(:not(.is-line-display-mode)) {
  .button-wrapper {
    position: absolute;
    bottom: -2px;
    right: 0;
    left: 0;

    .round-button {
      background-color: $primary-color;
      color: $white;
      border-radius: 100px;
      padding: 10px;
      height: 24px;
      box-shadow: 0px 2px 20px -1px rgba(0, 0, 0, 0.2), 0px 1px 1px 0px rgba(0, 0, 0, 0.14), 0px 1px 3px 0px rgba(0, 0, 0, 0.12);

      &.disabled {
        background-color: $white;
        color: $medium-light-grey;
      }
    }
  }
}

:host(.is-line-display-mode) {
  .grid {
    grid-template-columns: 160px minmax(178px, 1fr) 130px 185px;
    grid-template-rows: 1fr;
    grid-gap: 0 30px;

    .orgunit-and-title {
      align-items: start;
      @include truncate-with-ellipsis;

      .title,
      .orgunit {
        width: 100%;
      }

      .title {
        margin-bottom: 0;
      }
    }

    .detailed-infos {
      grid-template-columns: 1fr;
      grid-template-rows: 1fr 1fr 1fr;
      margin-bottom: 0;
    }

    .button-wrapper {
      justify-content: start;
      align-self: center;
      visibility: initial;

      > * {
        margin: 5px 0;
      }
    }
  }
}

:host(.is-access-controlled.is-line-display-mode) {
  border: 1px solid $red;

  .access-controlled {
    position: absolute;
    top: -12px;
    right: 10px;
    color: $red;
    display: grid;
    grid-template-columns: max-content max-content;
    align-items: center;
    gap: 10px;
    font-weight: bold;
    background-color: $white;
    padding: 0 5px;
  }
}

:host-context(body[ui='touch']) {
  .grid {
    .button-wrapper {
      visibility: initial;
    }
  }
}

@include isInDarkMode {
  border-color: $dark-mode-line;

  :host(.is-access-controlled.is-line-display-mode) {
    .access-controlled {
      background-color: $dark-mode-background;
    }
  }
}
